Resource Management is a commercial feature that must be unlocked before being used. To learn more about commercial features and how to unlock them visit http://www.oracle.com/technetwork/java/javaseproducts/
jdk.management.resource

## Class ResourceType

- java.lang.Object
- - jdk.management.resource.ResourceType

-     public class ResourceType
      extends Object

  A ResourceType with a name. The resource name is an opaque string and is not localized. A number of common `ResourceType`s are defined. `ResourceType`s may also be created by `of(java.lang.String)`.
  Since:
    8u40

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static ResourceType` | `DATAGRAM_OPEN` | DATAGRAM_OPEN - number of open datagram sockets.
    `static ResourceType` | `DATAGRAM_READ` | DATAGRAM_READ - number of bytes of datagrams read.
    `static ResourceType` | `DATAGRAM_RECEIVED` | DATAGRAM_RECIEVED - number of datagrams received.
    `static ResourceType` | `DATAGRAM_SENT` | DATAGRAM_SENT - number of datagrams sent.
    `static ResourceType` | `DATAGRAM_WRITE` | DATAGRAM_WRITE - number of bytes of datagrams written.
    `static ResourceType` | `FILE_OPEN` | FILE_OPEN - number of open files.
    `static ResourceType` | `FILE_READ` | FILE_READ - number of bytes read from files.
    `static ResourceType` | `FILE_WRITE` | FILE_WRITE - number of bytes written to files.
    `static ResourceType` | `FILEDESCRIPTOR_OPEN` | FILEDESCRIPTOR_OPEN - number of open file descriptors.
    `static ResourceType` | `HEAP_ALLOCATED` | HEAP_ALLOCATED - running total of heap allocations in bytes.
    `static ResourceType` | `HEAP_RETAINED` | HEAP_RETAINED - number of bytes of heap memory in use.
    `static ResourceType` | `SOCKET_OPEN` | SOCKET_OPEN - number of open sockets.
    `static ResourceType` | `SOCKET_READ` | SOCKET_READ - number of bytes read from sockets.
    `static ResourceType` | `SOCKET_WRITE` | SOCKET_WRITE - number of bytes written to sockets.
    `static ResourceType` | `STDERR_WRITE` | STDERR_WRITE - number of bytes written to the standard error stream.
    `static ResourceType` | `STDIN_READ` | STDIN_READ - number of bytes read from the standard input stream.
    `static ResourceType` | `STDOUT_WRITE` | STDOUT_WRITE - number of bytes written to the standard output stream.
    `static ResourceType` | `THREAD_CPU` | THREAD_CPU - amount of cpu time used by threads, in nanoseconds.
    `static ResourceType` | `THREAD_CREATED` | THREAD_CREATED - number of threads created and active.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `equals(Object obj)` | Indicates whether some other object is "equal to" this one based on the name.
    `String` | `getName()` | Returns the name of the resource.
    `int` | `hashCode()` | Returns a hash code value for this ResourceType based on the name.
    `static ResourceType` | `of(String name)` | Returns a ResourceType for the named resource.
    `String` | `toString()` | Returns a string representation of the object.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### FILE_OPEN

          public static final ResourceType FILE_OPEN

      FILE_OPEN - number of open files.

    - #### FILE_READ

          public static final ResourceType FILE_READ

      FILE_READ - number of bytes read from files.

    - #### FILE_WRITE

          public static final ResourceType FILE_WRITE

      FILE_WRITE - number of bytes written to files.

    - #### STDERR_WRITE

          public static final ResourceType STDERR_WRITE

      STDERR_WRITE - number of bytes written to the standard error stream.

    - #### STDIN_READ

          public static final ResourceType STDIN_READ

      STDIN_READ - number of bytes read from the standard input stream.

    - #### STDOUT_WRITE

          public static final ResourceType STDOUT_WRITE

      STDOUT_WRITE - number of bytes written to the standard output stream.

    - #### SOCKET_OPEN

          public static final ResourceType SOCKET_OPEN

      SOCKET_OPEN - number of open sockets.

    - #### SOCKET_READ

          public static final ResourceType SOCKET_READ

      SOCKET_READ - number of bytes read from sockets.

    - #### SOCKET_WRITE

          public static final ResourceType SOCKET_WRITE

      SOCKET_WRITE - number of bytes written to sockets.

    - #### DATAGRAM_OPEN

          public static final ResourceType DATAGRAM_OPEN

      DATAGRAM_OPEN - number of open datagram sockets.

    - #### DATAGRAM_RECEIVED

          public static final ResourceType DATAGRAM_RECEIVED

      DATAGRAM_RECIEVED - number of datagrams received.

    - #### DATAGRAM_SENT

          public static final ResourceType DATAGRAM_SENT

      DATAGRAM_SENT - number of datagrams sent.

    - #### DATAGRAM_READ

          public static final ResourceType DATAGRAM_READ

      DATAGRAM_READ - number of bytes of datagrams read.

    - #### DATAGRAM_WRITE

          public static final ResourceType DATAGRAM_WRITE

      DATAGRAM_WRITE - number of bytes of datagrams written.

    - #### THREAD_CREATED

          public static final ResourceType THREAD_CREATED

      THREAD_CREATED - number of threads created and active.

    - #### THREAD_CPU

          public static final ResourceType THREAD_CPU

      THREAD_CPU - amount of cpu time used by threads, in nanoseconds.

    - #### HEAP_RETAINED

          public static final ResourceType HEAP_RETAINED

      HEAP_RETAINED - number of bytes of heap memory in use.

    - #### HEAP_ALLOCATED

          public static final ResourceType HEAP_ALLOCATED

      HEAP_ALLOCATED - running total of heap allocations in bytes.

    - #### FILEDESCRIPTOR_OPEN

          public static final ResourceType FILEDESCRIPTOR_OPEN

      FILEDESCRIPTOR_OPEN - number of open file descriptors.

  - ### Method Detail

    - #### of

          public static ResourceType of(String name)

      Returns a ResourceType for the named resource.
      Parameters:
        `name` - the resource name
      Returns:
        a ResourceType for the named resource
      Throws:
        `IllegalArgumentException` - if the length of the name is zero

    - #### getName

          public String getName()

      Returns the name of the resource. Resource names are opaque strings that are not localized.
      Returns:
        the name of the resource

    - #### toString

          public String toString()

      Description copied from class: `java.lang.Object`
      Returns a string representation of the object. In general, the `toString` method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method.

      The `toString` method for class `Object` returns a string consisting of the name of the class of which the object is an instance, the at-sign character ``@`', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of:

      >      getClass().getName() + '@' + Integer.toHexString(hashCode())

      Overrides:
        `toString` in class `Object`
      Returns:
        a string representation of the object.

    - #### hashCode

          public int hashCode()

      Returns a hash code value for this ResourceType based on the name.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        Returns a hash code value based on the hashCode of the name.
      See Also:
        `Object.equals(java.lang.Object)`, `System.identityHashCode(java.lang.Object)`

    - #### equals

          public boolean equals(Object obj)

      Indicates whether some other object is "equal to" this one based on the name.
      Overrides:
        `equals` in class `Object`
      Parameters:
        `obj` - the reference object with which to compare
      Returns:
        true if the pother object is a ResourceType and name of this ResourceType is the same as the name of the other ResourceType; false otherwise.
      See Also:
        `Object.hashCode()`, `HashMap`

Copyright © 2014, 2026, Oracle and/or its affiliates. All rights reserved.